
#include <htc.h>
#define _XTAL_FREQ	20000000UL

__CONFIG(FOSC_HS & WDTE_OFF & LVP_OFF);

void PWM_Init(float frequency,unsigned char timer_prescalar);
void PWM_Set_Duty(unsigned char duty_cycle,unsigned char timer_presclar);
void PWM_Stop();

const unsigned int table[100] = 
{250 , 281 , 312 , 342 , 370 , 396 , 421 , 442 , 461 , 476 , 487 , 495 , 499 , 499 , 495 , 487 ,
476 , 461 , 442 , 421 , 396 , 370 , 342 , 312 , 281 , 250 , 218 , 187 , 157 , 129 , 103 , 78 ,
57 , 38 , 23 , 12 , 4 , 0 , 0 , 4 , 12 , 23 , 38 , 57 , 78 , 103 , 129 , 157 , 187 , 218 , 250 ,
281 , 312 , 342 , 370 , 396 , 421 , 442 , 461 , 476 , 487 , 495 , 499 , 499 , 495 , 487 , 476 ,
461 , 442 , 421 , 396 , 370 , 342 , 312 , 281 , 250 , 218 , 187 , 157 , 129 , 103 , 78 , 57 ,
38 , 23 , 12 , 4 , 0 , 0 , 4 , 12 , 23 , 38 , 57 , 78 , 103 , 129 , 157 , 187 , 218};

unsigned char i=0;
unsigned char flag = 0;
unsigned int value;

void interrupt Timer_ISR(void)
{
	TMR1H = 0xFE;
  	TMR1L = 0x09;
	i++;
	value = table[i];
	CCPR1L = (value>>2);
	value = value & 0x03;
	CCP1CON = CCP1CON | (value<<4);
	if(i >= 100)
		i=0;				
	TMR1IF = 0;
}

void main()
{
    TRISC2 = 0;
	T2CON = 0b00000101;
    PWM_Init(10000,4);
    T1CON = 0x01;
  	TMR1IF = 0;
  	TMR1H = 0xFE;
  	TMR1L = 0x09;
  	TMR1IE = 1;
  	INTCON = 0xC0;
    while(1)
    {
	    if(flag == 1)
	    {
		    value = table[i];
		    CCPR1L = (value>>2);
			value = value & 0x03;
			CCP1CON = CCP1CON | (value<<4);
			if(i >= 100)
				i=0;
			flag = 0;
	    }
	    
    }
}

void PWM_Init(float frequency,unsigned char timer_prescalar)
{
	float temp;
	TRISC2 = 0;
	/*
	PR2 = (FOSC/(4*PWMFreq*TMR2 Prescalar)-1)
	*/
    temp = _XTAL_FREQ/frequency;
    temp = temp/4;
    temp = temp/timer_prescalar;
    PR2 = (unsigned char)(temp);
    PR2 = PR2-1;
    CCPR1L = 0x00;
	CCP1CON = 0x0C;	//Set Zero Percent Duty Cycle Initially
}
void PWM_Set_Duty(unsigned char duty_cycle,unsigned char timer_prescalar)
{
	unsigned int register_value;
	float frequency;
	
	frequency = (_XTAL_FREQ/4);
	frequency = (frequency/timer_prescalar);
	frequency = (frequency/(PR2+1));	//Frequency of PWM Signal
	
	frequency = (frequency*100)/(duty_cycle);
	
	register_value = (_XTAL_FREQ)/(unsigned int)frequency;
	register_value = (register_value/timer_prescalar);

	CCPR1L = (register_value>>2);
	register_value = register_value & 0x03;
	CCP1CON = CCP1CON | (register_value<<4);
}

